package ru.ifmo.vizi.ctree.timer;

import java.awt.*;
import ru.ifmo.vizi.ctree.*;
import ru.ifmo.vizi.base.timer.*;

public class CTreeTimer extends Timer
{
    public static final int STEPS = 10;

    private CTreeVisualizer vizi;
    private Graph viewGraph;

    private Point[] beginCoords;
    private Point[] endCoords;
    private Point[] currentCoords;
    private int step;

    public CTreeTimer(CTreeVisualizer v, Graph gr, Graph destgr, Graph viewgr, CTree.Data d, int delay)
    {
        super(delay);
        vizi = v;
        viewGraph = viewgr;

        if (viewgr == gr)
        {
            beginCoords = gr.getCoords();
            currentCoords = gr.getCoords();
        }
        if (viewgr == destgr)
        {
            endCoords = destgr.getCoords();
        }

        Point[] tempCoords;
        if (viewgr == gr)
        {
            tempCoords = destgr.getCoords();
            endCoords = new Point[beginCoords.length];
            for (int i = 0; i < beginCoords.length; i++)
            {
                endCoords[i] = new Point( tempCoords[d.scc[i]] );
            }
        }
        if (viewgr == destgr)
        {
            tempCoords = gr.getCoords();
            beginCoords = new Point[endCoords.length];
            currentCoords = new Point[endCoords.length];
            for (int i = 0; i < endCoords.length; i++)
            {
                beginCoords[i] = new Point( tempCoords[d.scc[i]] );
                currentCoords[i] = new Point( tempCoords[d.scc[i]] );
            }
        }
        step = 0;
        viewGraph.setCoords(currentCoords);
    }

    public void tick()
    {
        step++;
        for (int i = 0; i < beginCoords.length; i++)
        {
            currentCoords[i].x = beginCoords[i].x +
                    (int) ((double) step * (endCoords[i].x - beginCoords[i].x) / STEPS);
            currentCoords[i].y = beginCoords[i].y +
                    (int) ((double) step * (endCoords[i].y - beginCoords[i].y) / STEPS);
        }
        viewGraph.setCoords(currentCoords);
        if (step == STEPS) vizi.clearTimer();
    }

    public boolean finished()
    {
        return step == STEPS;
    }
}